; Shifter - serial input module for BLINKENmini, LittleLights and BlinkenLeds
; entry code
; version 0.1 date 2006-02-20
; Copyright (C) 2005-2006 Stefan Schuermans <1stein@schuermans.info>
; Copyleft: GNU public license - http://www.gnu.org/copyleft/gpl.html
; a BlinkenArea project - http://www.blinkenarea.org/



; code entry point
ENTRY:
; initialize stack pointer
        ldi     TMP,RAMEND
        out     SPL,TMP
; set clock prescaler to 1:1
        ldi     TMP,1<<CLKPCE
        out     CLKPR,TMP
        ldi     TMP,0
        out     CLKPR,TMP
; set ports A and D to output (except PD0/RXD) and port B to input
        ldi     TMP,0x00
        out     PORTA,TMP
        out     PORTB,TMP
        out     PORTD,TMP
        ldi     TMP,0xFF
        out     DDRA,TMP
        ldi     TMP,0x00
        out     DDRB,TMP
        ldi     TMP,0xFE
        out     DDRD,TMP
; disable anlaog comparator
        ldi     TMP,0x80
        out     ACSR,TMP
; enable usart
        ldi     TMP,1<<U2X                      ; double speed
        out     UCSRA,TMP
        ldi     TMP,1<<RXEN|1<<TXEN             ; receiver and transmitter enabled
        out     UCSRB,TMP
        ldi     TMP,1<<UCSZ1|1<<UCSZ0           ; asynchronous, 8N1: 8 data bits, no parity, 1 stop bit
        out     UCSRC,TMP
        ldi     TMP,0                           ; speed = Fosc / (8 * (UBRR + 1))
        out     UBRRH,TMP                       ;       = 12MHz / (8 * (12 + 1))
        ldi     TMP,12                          ;       = 115384bps (115200bps, 0.16% deviation)
        out     UBRRL,TMP
; set up timer 0 (interrupt timer)
        ldi     TMP,1<<WGM01                    ; clear timer on compare match
        out     TCCR0A,TMP
        ldi     TMP,1<<CS01|1<<CS00             ; use system clock with prescaler 1:64 (5.333us)
        out     TCCR0B,TMP
        ldi     TMP,36                          ; cycle time 36 timer steps (192us)
        out     OCR0A,TMP
        ldi     TMP,1<<OCIE0A                   ; timer 0 compare match interrupt enabled
        out     TIMSK,TMP
; set up timer 1 (timeout timer)
        ldi     TMP,0                           ; clear timer on compare match
        out     TCCR1A,TMP
        ldi     TMP,1<<CS12|1<<CS10|1<<WGM12    ; use system clock with prescaler 1:1024 (85.333us)
        out     TCCR1B,TMP
        ldi     TMP,0                           ; no output compare
        out     TCCR1C,TMP
        ldi     TMP,228                         ; timer steps 58594 (cycle time 5s)
        out     OCR1AH,TMP
        ldi     TMP,226
        out     OCR1AL,TMP
; enable watchdog (64ms)
        wdr
        ldi     TMP,1<<WDCE|1<<WDE
        out     WDTCR,TMP
        ldi     TMP,1<<WDE|1<<WDP1
        out     WDTCR,TMP
        wdr
; jump to main program
        rjmp    MAIN
