; Shifter - serial input module for BLINKENmini, LittleLights and BlinkenLeds
; main loop
; version 0.1 date 2006-02-20
; Copyright (C) 2005-2006 Stefan Schuermans <1stein@schuermans.info>
; Copyleft: GNU public license - http://www.gnu.org/copyleft/gpl.html
; a BlinkenArea project - http://www.blinkenarea.org/



; main loop
;  - used stack depth: 2
MAIN:
        wdr                                     ; watchdog reset
        clr     STEP                            ; output step counter to first output step
        clr     OUT_PTR_FLAG                    ; initialize output buffer pointers
        rcall   OUT_FLIP
        rcall   OUT_PIC                         ; show standard picture
        clr     SNES_FLAG                       ; no new SNES key data available
        clr     RECV_STEP                       ; start receiving with a new message
        clr     TRANS_STEP                      ; start transmitting with first byte
        clr     TMP                             ; reset timer 1 (timeout timer)
        out     TCNT1H,TMP
        out     TCNT1L,TMP
        in      TMP,OCF1A                       ;  - clear timeout flag (timer 1 compare match)
        sbr     TMP,1<<OCF1A
        out     TIFR,TMP
        sei                                     ; turn on interrupts

MAIN_LOOP:

; watchdog reset
        wdr

; receive serial data
        rcall   RECV

; transmit serial data
.IF CONF_SNES
        rcall   TRANS
.ENDIF

; timeout -> show standard picture
        in      TMP,TIFR                        ; skip if timeout flag (timer 1 compare match) is set
        sbrs    TMP,OCF1A
        rjmp    MAIN_TIMEOUT_END
        rcall   OUT_PIC                         ; show standard picture
        cli                                     ; turn off interrupts
        in      TMP,OCF1A                       ; clear timeout flag (timer 1 compare match)
        sbr     TMP,1<<OCF1A
        out     TIFR,TMP
        sei                                     ; turn on interrupts
MAIN_TIMEOUT_END:

; bottom of main loop
        rjmp     MAIN_LOOP

